import React, { useState, useEffect } from 'react';
import { Form, Modal, Input, Select, notification, DatePicker } from 'antd';
import styles from './taskScheduling.less'
import { ConfigProvider } from 'antd';

// import moment from 'moment';
// import locale from 'antd/es/date-picker/locale/zh_CN';
// import 'moment/locale/zh-cn';

import moment from 'moment'
import locale from 'antd/lib/date-picker/locale/zh_CN'
import 'moment/locale/zh-cn'
moment.locale('zh-cn')

import {
  getIotDeviceType, algorithmList, getEquipmentInfo
} from '@/services/intelligence/api';


const { RangePicker } = DatePicker;
const { TextArea } = Input;
const AddModal = props => {
  const { callBackSubmit = () => { }, type, formObj, visible, solutionNames } = props;
  const [loading, setLoading] = useState(false);
  const [workSpace, setWorkSpace] = useState(''); //
  const [workList, setWorkList] = useState([]); //设备类型列表
  const [deviceType, setDeviceType] = useState([]); //设备类型列表
  const [deviceCode, setDeviceCode] = useState([]); //设备编码列表
  const [timeType, setTimeType] = useState(['分钟', '小时', '天']);
  const [intervalType, setIntervalType] = useState('分钟')
  const [gsIp, setGsIp] = useState([]);
  const [form] = Form.useForm();
  const { Item } = Form;
  // 提交
  const onSubmit = () => {
    form.validateFields().then(validate => {
      if (validate) {
        setLoading(true);
        let obj = form.getFieldsValue();
        if (type === 'add') {


        } else if (type === 'edit') {
          handleEdit();
        }
      }
    });
  };

  const handleEdit = () => {
    // SetServiceConfig({
    //   servicename: serviceName,
    //   terminalType: 'base',
    //   isBaseMap: true,
    //   jsonCfg: JSON.stringify(query)
    // })
    //   .then(res => {
    //     setLoading(false);
    //     if (res.success) {
    //       form.resetFields();
    //       callBackSubmit();
    //       notification.success({
    //         message: '提示',
    //         duration: 3,
    //         description: res.message || '编辑成功',
    //       });
    //     } else {
    //       notification.error({
    //         message: '提示',
    //         duration: 3,
    //         description: res.message || '编辑失败',
    //       });
    //     }
    //   })
    //   .catch(err => setLoading(false));
  };

  const onFinish = value => { };
  useEffect(() => {
    switch (type) {
      case 'add':
        getDeviceInfo()
        break;
      case 'edit':
        form.setFieldsValue({ ...formObj });
        break;
      default:
        break;
    }
  }, [visible]);


  const getDeviceInfo = () => {
    const getIotDevice = getIotDeviceType()
    const algorithm = algorithmList()
    Promise.all([getIotDevice, algorithm]).then(res => {
      if (res[0].getMe.length) {
        setDeviceType(res[0].getMe)
        getEquipmentInfo(res[0].getMe[0].DeviceType).then(respone => {
          respone.getMe[0].DeviceList.length && setDeviceCode(respone.getMe[0].DeviceList)
          form.setFieldsValue({ deviceType: res[0].getMe[0].DeviceType, deviceCode: respone.getMe[0].DeviceList[0].Code });
        })
      }
    })
  }
  const layout = {
    layout: 'horizontal',
    labelCol: {
      span: 4,
    },
    wrapperCol: {
      span: 16,
    },
  };

  const handleWorkspace = () => { }
  const handleIntervalType = (value) => {
    setIntervalType(value)
  }

  return (
    <Modal
      title={`${type === 'add' ? '元数据发布' : '编辑'}`}
      bodyStyle={{ width: '100%', minHeight: '100px' }}
      style={{ top: '150px' }}
      width="700px"
      destroyOnClose
      maskClosable={false}
      cancelText="取消"
      okText="确认"
      {...props}
      onOk={() => onSubmit()}
      confirmLoading={loading}
      forceRender={true}
      getContainer={false}
    >
      {visible && (
        <Form form={form} {...layout} onFinish={onFinish}>
          <Item
            label="任务名称"
            name="TaskName"
            rules={[{ required: true, message: '请输入任务名称' }]}
          >
            <Input placeholder="请输入任务名称" allowClear />
          </Item>
          <Item
            label="场景"
            name="scene"
            rules={[{ required: true, message: '请选择场景' }]}
          >
            <Select onChange={handleWorkspace} >
              {/* {workList.length ? workList.map((item, index) => { return <Option key={index} value={item.name}>{item.name}</Option> }) : ''} */}
            </Select>
          </Item>

          <Item
            label="策略名称"
            name="strategy"
            rules={[{ required: true, message: '请选择策略名称' }]}
          >
            <Select onChange={handleWorkspace} >
              {/* {workList.length ? workList.map((item, index) => { return <Option key={index} value={item.name}>{item.name}</Option> }) : ''} */}
            </Select>
          </Item>
          <Item
            label="类型"
            name="type"
            rules={[{ required: true, message: '请选择类型' }]}
          >
            <Select onChange={handleWorkspace} >
              <Select.Option value='水龄预测'>水龄预测</Select.Option>
              <Select.Option value='二供泵房'>二供泵房</Select.Option>
            </Select>
          </Item>
          <Item
            label="设备类型"
            name="deviceType"
            rules={[{ required: true, message: '请输入设备类型' }]}
          >
            <Select onChange={handleWorkspace} >
              {deviceType.length ? deviceType.map((item, index) => { return <Select.Option key={index} value={item.DeviceType}>{item.DeviceType}</Select.Option> }) : ''}
            </Select>
          </Item>
          <Item
            label="设备编码"
            name="deviceCode"
            rules={[{ required: true, message: '请选择设备编码' }]}
          >
            <Select onChange={handleWorkspace} >
            {deviceCode.length ? deviceCode.map((item, index) => { return <Select.Option key={index} value={item.PointAddressID}>{item.Code}</Select.Option> }) : ''}
            </Select>
          </Item>

          <Item
            label="间隔(Cron)"
            name="Interval"
            rules={[{ required: true, message: '请输入间隔' }]}
          >
            <Input placeholder="请输入间隔" allowClear />
          </Item>
          <Item
            label="首次预测时间"
            name="Date"
            rules={[{ required: true, message: '请选择首次预测时间' }]}
          >

            <RangePicker locale={locale}
              style={{ width: '100%' }} />
          </Item>
          <Item
            label="预测间隔"
            rules={[{ required: true, message: '请输入预测间隔' }]}
          >
            <div className={styles.predict}></div>
            <Input style={{ width: '70%' }} placeholder="请输入预测间隔" allowClear />
            <Select style={{ marginLeft: '0.5rem', width: '28%' }} onChange={handleIntervalType} value={intervalType}>
              {timeType.length ? timeType.map((item, index) => { return <Select.Option key={index} value={item}>{item}</Select.Option> }) : ''}
            </Select>
          </Item>

          <Item
            label="描述"
            name="des"
          >
            <TextArea placeholder="可输入描述信息" rows={4} allowClear />
          </Item>
        </Form>
      )}
    </Modal>
  );
};
export default AddModal;
